#include "stdafx.h"
#include "MyGL.h"


//------------------------------------------------------------------------------
MyGL::MyGL()
: 
_doLighting( false ),
_doClipping( false ),
_doTriangulate( false ),
_doRasterize( false )
{}

//------------------------------------------------------------------------------
MyGL::~MyGL()
{}

//------------------------------------------------------------------------------
bool MyGL::ComputeLighting( vector<GLVertex>& verts )
{ 
	if( !_doLighting )
		return false;

	//
	// YOUR CODE HERE 
	//

	// for just multiply material and lighting diffuse together
	if( light.enabled )
	{
		for( int i=0; i < (int)verts.size(); i++ )
			verts[i].color = light.diffuse * material.diffuse;
	}
	return true;
}

//------------------------------------------------------------------------------
bool MyGL::ClipPolygon( const vector<GLVertex>& vertsIn, vector<GLVertex>& vertsOut )
{  
	if( !_doClipping )
		return false;

	//
	// YOUR CODE HERE
	//

	// Ŭ  ο position  ð̳ ̵忡 ִ  ϸ ˴ϴ.
	// ̶ GLVertex  ִ ٸ  color, normal, texture coordinate     մϴ.

	// implement cliping. you can use method that is learned in the class.
	// other values in GLVertex calculate the same way. (color, normal, texture coordinat)


	// just copy the polygon so we can get to the other parts of the pipeline
	vertsOut = vertsIn;  
	return true;
}

//------------------------------------------------------------------------------
bool MyGL::TriangulatePolygon( const vector<GLVertex>& polygonVerts,
							  vector<GLVertex>& triangleVerts )
{
	if( !_doTriangulate )
		return false;

	//
	// YOUR CODE HERE
	//

	// ⿡ ﰢȭ(Triangulate)   Ѵ.
	// F1 Ű   簢  ﰢȭ(triangulize)   ٸ Ÿµ,
	// ũ Ű澲 ʾƵ ˴ϴ.
	// 簢   ä    ֽϴ.

	// implement Triangulate
	// if you press F1, a box is appeared
	// the box's color will be depend on your implementation. 
	// Maybe it is different from hardware rendering. you don't need to worry about it.
	// but you must fill color right way. you can know if you see your result.
	// 


	// just make a triangle out of the first three vertices for now
	triangleVerts.push_back( polygonVerts[0] );
	triangleVerts.push_back( polygonVerts[1] );
	triangleVerts.push_back( polygonVerts[2] );
	return true;
}

//------------------------------------------------------------------------------
bool MyGL::RasterizeTriangle( GLVertex verts[3] )
{
	if( !_doRasterize )
		return false;

	// 
	// YOUR CODE HERE
	//

	// ⿡ Rasterization  ϸ ȴ.
	// w Ű  Ÿ wire mode   ʿ .

	// Implement rasterization 
	// you don't need to implement wire mode which is appeared if you press key 'w'

	// just render the vertices for now
	for( int i=0; i < 3; i++ )
	{
		GLVertex& v = verts[i];
		RGBAColor color;

		if( textureEnabled  )
		{
			if( texture.id != 0 )
			{
				// look up color in the texture
				int x = v.texCoord[0] * (texture.width - 1);
				int y = v.texCoord[1] * (texture.height - 1);
				color = texture.GetPixel( x, y, 0 );
			}
		}
		else
			color = v.color;

		frameBuffer.SetPixel( v.position[0], v.position[1], color );

		// depthTestEnabled  ȸ  ׸ 0 ǰ,  ܿ 1 ȴ.
		
		// depthTestEnabled is 0 if the polygon is background
		// depthTestEnabled is 1 for other cases.

		if( depthTestEnabled )
			frameBuffer.SetDepth( v.position[0], v.position[1], v.position[2] );
	}

	return true;
}

